﻿#region "Copyright (C) Lenny Granovsky. 2005-2013"
//This program is free software distribute under the terms of the GNU General Public License as published by
//the Free Software Foundation. Please read AssemblyInfo.cs file for more information.
#endregion

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Runtime.Serialization;

namespace Web.Enhancements.Rest.Filters
{
    [Serializable()]
    public class WebRestSecurityException : Exception
    {
        public WebRestSecurityException()
            : base("WebRest process thrown a security exception.")
        {
        }

        public WebRestSecurityException(string message)
            : base(message)
        {
        }

        public WebRestSecurityException(string message, Exception innerException)
            : base(message, innerException)
        {
        }

        public WebRestSecurityException(string format, object arg0, Exception innerException)
            : this(string.Format(format, arg0), innerException)
        {
        }

        public WebRestSecurityException(string format, object arg0)
            : this(string.Format(format, arg0))
        {
        }

        public WebRestSecurityException(string format, object arg0, object arg1, Exception innerException)
            : this(string.Format(format, arg0, arg1), innerException)
        {
        }

        public WebRestSecurityException(string format, object arg0, object arg1)
            : this(string.Format(format, arg0, arg1))
        {
        }

        public WebRestSecurityException(string format, object arg0, object arg1, object arg2, Exception innerException)
            : this(string.Format(format, arg0, arg1, arg2), innerException)
        {
        }

        public WebRestSecurityException(string format, object arg0, object arg1, object arg2)
            : this(string.Format(format, arg0, arg1, arg2))
        {
        }

        protected WebRestSecurityException(SerializationInfo info, StreamingContext context)
            : base(info, context)
        {
        }
    }
}
