﻿#region "Copyright (C) Lenny Granovsky. 2005-2013"
//This program is free software distribute under the terms of the GNU General Public License as published by
//the Free Software Foundation. Please read AssemblyInfo.cs file for more information.
#endregion

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Web.Enhancements.Rest
{
    /// <summary>
    /// Enumeration is used by WebRestMethodAttribute to describe HTTP Method that is allowed for specific method to be used.
    /// </summary>
    public enum HttpMethodRequirement
    {
        /// <summary>
        /// Only GET is allowed.
        /// </summary>
        GetOnly,
        /// <summary>
        /// Only POST is allowed.
        /// </summary>
        PostOnly,
        /// <summary>
        /// Either GET or POST is allowed. This is default value.
        /// </summary>
        GetOrPost,
        /// <summary>
        /// Only DELETE is allowed. Make sure ASP.NET web.config and IIS allow this HTTP method.
        /// </summary>
        DeleteOnly,
        /// <summary>
        /// Only PUT is allowed. Make sure ASP.NET web.config and IIS allow this HTTP method.
        /// </summary>
        PutOnly
    }
}
