﻿#region "Copyright (C) Lenny Granovsky. 2005-2013"
//This program is free software distribute under the terms of the GNU General Public License as published by
//the Free Software Foundation. Please read AssemblyInfo.cs file for more information.
#endregion

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Web;
using System.Web.UI;

namespace Web.Enhancements.Rest.Templates
{
    /// <summary>
    /// Interface that class must implement to be able to return data through REST services that should be 
    /// processed using HTML Template before sending response back to client.
    /// </summary>
    public interface ITemplatedResult
    {
        /// <summary>
        /// Method renders result's content into given HTTP response object.
        /// </summary>
        /// <param name="response">HTTP response object.</param>
        void RenderResult(System.Web.HttpResponse response);
    }
}
