﻿#region "Copyright (C) Lenny Granovsky. 2005-2013"
//This program is free software distribute under the terms of the GNU General Public License as published by
//the Free Software Foundation. Please read AssemblyInfo.cs file for more information.
#endregion

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Web.Enhancements.Rest.Templates
{
    /// <summary>
    /// Class that provides ability to return data through REST services that should be 
    /// processed as JSON-formatted data to respond back to the client.
    /// </summary>
    internal class JsonTemplate : ITemplatedResult
    {
        /// <summary>
        /// Gets or sets result data that should be returned to the client.
        /// </summary>
        public object ResultData { get; set; }

        /// <summary>
        /// Default constructor.
        /// </summary>
        public JsonTemplate()
        {
        }

        /// <summary>
        /// Contsractor that accpets result data that class should process into JSON response.
        /// </summary>
        /// <param name="resultData">Result data as an object</param>
        public JsonTemplate(object resultData)
        {
            this.ResultData = resultData;
        }

        /// <summary>
        /// Method converts ResultData object to JSON format and renders content into given HTTP response object.
        /// </summary>
        /// <param name="response">HTTP response object.</param>
        public void RenderResult(System.Web.HttpResponse response)
        {
            System.Web.Script.Serialization.JavaScriptSerializer jsonSerializer;
            jsonSerializer = new System.Web.Script.Serialization.JavaScriptSerializer();
            System.Text.StringBuilder sbr = new System.Text.StringBuilder();
            jsonSerializer.Serialize(this.ResultData, sbr);
            response.Write(sbr.ToString());
        }
    }
}
