﻿#region "Copyright (C) Lenny Granovsky. 2005-2013"
//This program is free software distribute under the terms of the GNU General Public License as published by
//the Free Software Foundation. Please read AssemblyInfo.cs file for more information.
#endregion

using System;
using System.Collections.ObjectModel;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.ComponentModel;

namespace Web.Enhancements.Rest.WebControls
{
    /// <summary>
    /// Class represents the collection of class references that REST service should support.
    /// </summary>
    public class ClassReferenceCollection : Collection<ClassReference>
    {
        /// <summary>
        /// Default constructor.
        /// </summary>
        public ClassReferenceCollection()
        {
        }
    }

    /// <summary>
    /// Represents the REST-service class reference information used to create a web-client javascript proxy.
    /// </summary>
    [DefaultProperty("FullClassName")]
    public class ClassReference
    {
        /// <summary>
        /// Gets or sets the full class name, including namespace.
        /// </summary>
        public string FullClassName { get; set; }
        /// <summary>
        /// Gets or sets the assembly name containing referenced class.
        /// </summary>
        public string Assembly { get; set; }
        /// <summary>
        /// Default constructor.
        /// </summary>
        public ClassReference()
        {
            this.FullClassName = "";
            this.Assembly = "";
        }
    }
}
