﻿#region "Copyright (C) Lenny Granovsky. 2005-2013"
//This program is free software distribute under the terms of the GNU General Public License as published by
//the Free Software Foundation. Please read AssemblyInfo.cs file for more information.
#endregion

using System;
using System.Collections.ObjectModel;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.ComponentModel;

namespace Web.Enhancements.Rest.WebControls
{
    /// <summary>
    /// Class represents the collection of script references that REST service should support.
    /// </summary>
    public class ScriptReferenceCollection : Collection<ScriptReference>
    {
        /// <summary>
        /// Default constructor.
        /// </summary>
        public ScriptReferenceCollection()
        {
        }
    }

    /// <summary>
    /// Represents the javascript reference information used to include file within web-page on the client.
    /// </summary>
    [DefaultProperty("Path")]
    public class ScriptReference
    {
        /// <summary>
        /// Gets or sets the script reference name.
        /// </summary>
        public string Name { get; set; }
        /// <summary>
        /// Gets or sets the javascript file path.
        /// </summary>
        public string Path { get; set; }
        /// <summary>
        /// Default constructor.
        /// </summary>
        public ScriptReference()
        {
            this.Name = "";
            this.Path = "";
        }
    }
}
